#include <io.h>
#include <interrupt.h>
#include <sig-avr.h>
#include <timer.h>

#include "led.h"
#include "lcd_hd44780.h"

unsigned char durchgang ;
unsigned long anzahl;

unsigned char select = 0,*menu[] = {" josef's tricy","remote control","wecker","test" };

void delay_1p125ms(){
  timer0_source(0x03);
  timer0_start();
  while(inp(TCNT0) < 71);    
}

void semi_delay_1p125ms(){
  timer0_source(0x03);
  timer0_start();
  while(inp(TCNT0) < 35);      
}


void delay2p5ms(){
  unsigned char temp1,temp2;
  temp1 = 0x21;
  while(temp1 > 0) {
    temp2 = 0xc9; 
    while(temp2!=0) temp2--; 
    temp1--;
  }
}

void delay_1s(unsigned int s){
  unsigned long s2 = s*1000/5*2;
  while(s2-->0)delay2p5ms();
}


void blinker(){
  unsigned int i;
  while(1){
    ledinvert_mask(16);
    for(i=0;i<5000;i++)delay_1p125ms();    
    
  }}



/*


SIGNAL(SIG_INTERRUPT0){
  unsigned char werte[64];
  unsigned char temp, i,c;

  semi_delay_1p125ms();
  for(i=0;i<sizeof(werte);i++){
    werte[i] = bit_is_set(PIND,2) ? '1' : '0';
    delay_1p125ms();
  }

  led_mask(LEDMASK_ALL);
  for(c=0;c<sizeof(werte)/16;c++){
    lcd_clear();
    for(i=0;i<16;i++) lcd_putchar(werte[c*16+i]);
    delay_1s(10);
  }
  led_mask(LEDMASK_NONE);


}

*/








SIGNAL(SIG_INTERRUPT0){ 
  unsigned char temp, buffer[20];
  unsigned int i;

  if(select == 3){

  if(inp(MCUCR) & 0x01){
    timer0_source(0x05);
    timer0_start();
    led_mask(LEDMASK_ALL);    
    outp(0x2,MCUCR);    
  }
  else {
    timer0_stop();
    outp(0x3,MCUCR);
    lcd_clear();
    i = inp(TCNT0);
    itoa(i,buffer,10);
    lcd_puts(buffer);
    delay_1s(2);
    led_mask(LEDMASK_NONE);
  }

  }

}






int main(){
  unsigned char temp,temp2;  
  

  select = 0;

  outp(0x00,DDRD);
  outp(0x00,PORTD);
  outp(0x00,DDRA);
  outp(0x00,PORTA);

  outp(0x40,GIMSK);
  outp(0x03,MCUCR);
  durchgang = 0x00;

  
  lcd_init();
  lcd_clear();
  lcd_gotoxy(0,0);
  lcd_puts(menu[select]);
  sei();
  
  
  while(1){
    temp = inp(PINA);
    if((temp & 0x08) > 0){
      led_mask(temp);
      select++;
      select %= sizeof(menu)/sizeof(&menu);
      lcd_clear();
      lcd_puts(menu[select]);   
      delay_1s(1);      
      led_mask(LEDMASK_NONE);
    } 

  }

  
  

}
